org.apache.lucene.index

## Class NumericDocValues

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.index.NumericDocValues

Direct Known Subclasses:
  FilterNumericDocValues

    public abstract class NumericDocValues
    extends DocIdSetIterator

A per-document numeric value.

### Field Summary

### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

`NO_MORE_DOCS`

### Constructor Summary

Constructors
`protected` `NumericDocValues()` Sole constructor.

### Method Summary

All Methods Instance Methods Abstract Methods
`abstract boolean` `advanceExact(int target)` Advance the iterator to exactly `target` and return whether `target` has a value.
`abstract long` `longValue()` Returns the numeric value for the current document ID.

### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

`advance, all, cost, docID, empty, nextDoc, range, slowAdvance`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### NumericDocValues

    protected NumericDocValues()

Sole constructor. (For invocation by subclass constructors, typically implicit.)

### Method Detail

#### longValue

    public abstract long longValue()
                            throws IOException

Returns the numeric value for the current document ID. It is illegal to call this method after `advanceExact(int)` returned `false`.

Returns:
  numeric value
Throws:
  `IOException`

#### advanceExact

    public abstract boolean advanceExact(int target)
                                  throws IOException

Advance the iterator to exactly `target` and return whether `target` has a value. `target` must be greater than or equal to the current `doc ID` and must be a valid doc ID, ie. ≥ 0 and < `maxDoc`. After this method returns, `DocIdSetIterator.docID()` returns `target`.

Throws:
  `IOException`